/*
 * Copyright  2008 Nokia Corporation.
 */

#include "CWavLoader.h"
#include <e32svr.h>
#include <f32file.h>
#include <aknutils.h>


CWavLoader* CWavLoader::NewL()
  {
  CWavLoader* self = NewLC();
  CleanupStack::Pop( self );
  return self;
  }


CWavLoader* CWavLoader::NewLC()
  {
  CWavLoader* self = new( ELeave )CWavLoader();
  CleanupStack::PushL( self );
  self->ConstructL();
  return self;
  }


CWavLoader::~CWavLoader()
  {
  }


CWavLoader::CWavLoader()
  {
  }


void CWavLoader::ConstructL()
  {
  }


TSample CWavLoader::LoadL( const TFileName& aFileName )
  {
  TFileName nameAndPath;
  
  // Get application's private path
  // This is e.g. '\Private\20001978\'
  CEikonEnv::Static()->FsSession().PrivatePath( nameAndPath );
  
  nameAndPath.Append(aFileName);
  
  RFs fs;
  User::LeaveIfError(fs.Connect());
  RFile file;
  CleanupClosePushL( fs );
  CleanupClosePushL( file );
  User::LeaveIfError( file.Open( fs, nameAndPath, EFileStream | EFileRead ) );
  TInt size;
  User::LeaveIfError( file.Size( size ) );

  TUint8* tbuf = new( ELeave )TUint8[ size ];
  CleanupStack::PushL(tbuf);
  
  TPtr8 ptr( (TUint8*)tbuf, size );
  User::LeaveIfError( file.Read( ptr ) ); 
  
  TInt16* buf = new( ELeave )TInt16[ size ];
  TInt i;
  for( i=0; i<size; i++ )
    {
    TInt v = tbuf[ i ];
    v -= 128;
    buf[ i ] = ( TInt16 )( v * 256 );
    }

  CleanupStack::PopAndDestroy( 3 ); // fs, file
  
  TSample sample;
  sample.iData = buf;
  sample.iLength = size;
  sample.iRepStart = 0;
  sample.iRepEnd = 0;
  
  return sample;
  }
  
// End of File
