/*
 * Copyright  2008 Nokia Corporation.
 */


#ifndef __CWAVLOADER_H__
#define __CWAVLOADER_H__

// INCLUDES
#include <e32base.h>
#include "TSample.h"

// CLASS DECLARATION
/**
* CWavLoader loads raw ( only sample data ) wav files
* which is 8-bit mono.
*
* Example:
*
* CWavLoader* loader = CWavLoader::NewLC();
* iSample = loader->LoadL( _L("sample.wav") );
* CleanupStack::PopAndDestroy( loader );
*/
class CWavLoader
  : public CBase
  {
  public:
    /// Two phased constructor
    static CWavLoader* NewL();

    static CWavLoader* NewLC();

    /// Default destructor
    ~CWavLoader();

  private:

    /// Default constructor
    CWavLoader();

    /// second phase constructor
    void ConstructL();

  public:

    /// Loads wav file and creates sample from it.
    /// Leaves on any error.
    /// @param aFileName file name with path
    /// @return pointer to constructed sample
    TSample LoadL( const TFileName& aFileName );
  };
  
#endif

// End of File
