/*
 * Copyright  2008 Nokia Corporation.
 */

#include <e32base.h>
#include "MyActive.h"
#include "CMixerThread.h"

// Constructs and sets priority
MyActive::MyActive(CMixerThread* aThread):
CActive(CActive::EPriorityStandard),iThread(aThread)
  {
  // adds the active to the queue
  CActiveScheduler::Add(this) ; 
  }


// Cancels this task
void MyActive::DoCancel()
  {
    TRequestStatus* status = &iStatus;
    RThread().RequestComplete(status,KErrCancel);
  }


// Request accepting function
void MyActive::Request()
  {
  SetActive();  
  iStatus = KRequestPending;
  }


// Informs the requestor that there is a user activity
// or timer is fired
void MyActive::RunL()
  {
  if(iStatus == KErrNone)
      {
      iThread->HandleExceptionL();
      Request();
      }
  }

// End of File
