/*
 * Copyright  2008 Nokia Corporation.
 */

#ifndef __SOUNDMIXERCONTAINER_H__
#define __SOUNDMIXERCONTAINER_H__

// INCLUDES

#include <coecntrl.h>
#include <coemain.h>
#include <mdaaudiooutputstream.h>
#include <mda\common\audio.h>
#include "TSample.h"

// FORWARD DECLARATIONS
class CSndMixer;

// CLASS DECLARATION
/**
*  CSoundMixerContainer  container control class.
*  
*/
class CSoundMixerContainer 
{
  public: // Constructors and destructor
       
	static CSoundMixerContainer* CSoundMixerContainer::NewL();
	static CSoundMixerContainer* CSoundMixerContainer::NewLC();
    // Second phase constructor
    void ConstructL();
    // Default destructor
    ~CSoundMixerContainer();
    CSoundMixerContainer::CSoundMixerContainer();

    
    
    void HandleGainingForeground();
    void HandleLosingForeground();


  public: // for AppUI

    /// Starts mixer
    void StartMixer();

    /// Stops mixer
    void StopMixer();

    /// increases volume
    void VolumeUp();

    /// decreases volume
    void VolumeDown();

    /// determines whether current profile is silent
    TBool IsProfileSilent();

    void CSoundMixerContainer::StartBGM();
    void CSoundMixerContainer::StopBGM();
    void CSoundMixerContainer::SetVolume(TInt volume);
    void CSoundMixerContainer::PlaySmallBoom();
    void CSoundMixerContainer::PlayMidBoom();
    void CSoundMixerContainer::PlayLargeBoom();
    
  private: // data

    CSndMixer*  iSndMixer;      // Sound mixer

    TSample   iMusicSample;   // sampled music
    TSample   iEffectSmlBoom;    // sound effect
    TSample   iEffectMidBoom;   // sound effect
    TSample   iEffectLrgBoom;   // sound effect

    };

#endif

// End of File
