/*
 * Copyright  2008 Nokia Corporation.
 */

#ifndef __TAUDIOSHARED_H__
#define __TAUDIOSHARED_H__

// INCLUDES
#include <e32std.h>
#include "TSample.h"

// CONSTANTS
const TInt KMaxChannels = 16;
const TInt KAudioShift = 12;

// ENUMERATIONS
enum TMixerCmd
  {
  ECmdStartMixer = 0,
  ECmdStopMixer,
  ECmdDestroyMixer
  };

// CLASS DECLARATION
/**
* TAudioShared is internal type for sound mixer application.
* This struct is used for inter-thread data trasfer and
* communication
*/

class TAudioShared
  {
  public:
    /// for thread end signaling
    RSemaphore  iAliveMutex;

    /// for sample attribute change signaling
    RMutex  iMutex;

    /// pause flag
    TBool iPaused;

    /// sample attributes
    TSample iSample[ KMaxChannels ];
    TInt  iVolume[ KMaxChannels ];
    TInt  iFrequency[ KMaxChannels ];
    TBool iPlayStarted[ KMaxChannels ];
    TExcType        iExc;
    TRequestStatus* iStatusPtr;
    
    /// main volume
    TInt  iMainVolume;

    /// Command parameter
    TMixerCmd iCmd;
  };

#endif

// End of File
